
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.function.Consumer;
import java.util.function.Predicate;

public class Roster {

    public static void printPersons(
            List<Person> roster, 
            Predicate<Person> tester,
            Consumer<Person> consumer) 
    {
        for (Person p : roster) {
            if (tester.test(p)) {
                //p.printPerson();
                consumer.accept(p);
            }
        }
    }
    
    public static void main(String[] args) {
        List<Person> roster = Arrays.asList(
                new Person("Pepa", LocalDate.of(1988, 10, 30)),
                new Person("Karel", LocalDate.of(1996, 8, 12))
        );
        
        printPersons(
                roster, 
                (Person p) -> p.getAge() >= 18 && p.getAge() < 25,
                p -> p.printPerson()
        );
        
        /*
        printPersons(
                roster, 
                new CheckPerson() { // new Predicate<Person>() {
                    public boolean test(Person p) {
                        return p.getAge() >= 18 && p.getAge() < 25;
                    }
                }
        );
        */
    }
    
}
